"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _index = require("../../index");

var _DeferredTmpl = _interopRequireDefault(require("./DeferredTmpl"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var state = function state() {
  return {
    InnerComponent: null
  };
};
/**
 * @description
 * Deferred Component Wrapper
 * @param {function} fetchComponent - DeferredComponent import statement
 * @returns {JSX} PReact DeferredComponent Componentimport DeferredTmpl from './DeferredTmpl';
 */


var _default = (0, _index.withState)({
  state: state,
  componentDidMount: function componentDidMount(_ref) {
    var setState = _ref.setState,
        getComponent = _ref.getComponent;
    getComponent().then(function (comp) {
      var InnerComponent = comp["default"];
      return setState({
        InnerComponent: InnerComponent
      });
    });
  },
  template: _DeferredTmpl["default"]
})();

exports["default"] = _default;