"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = component;
exports.injectStore = injectStore;

var _react = _interopRequireWildcard(require("react"));

var _getProps = _interopRequireDefault(require("../util/getProps"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ACTION_KEY = 'action';
var HANDLER_KEY = 'handler';

var isObject = function isObject(target) {
  return Object.prototype.toString.call(target) === '[object Object]';
};

var store = {};

function attachInstanceProps(instanceProps) {
  var _this = this;

  this.instanceProps = instanceProps || {};

  this.getInstanceProps = function () {
    return _this.instanceProps;
  };

  this.setInstanceProps = function (newVal) {
    if (!isObject(newVal)) {
      return {};
    }

    var currentVal = _this.instanceProps;
    return _this.instanceProps = _objectSpread({}, currentVal, {}, newVal);
  };
}

function bindHandler(handlers, modifier, TARGET_PROP_NAME) {
  var _this2 = this;

  this[TARGET_PROP_NAME] = {};
  handlers && Object.keys(handlers).map(function (key) {
    var fn = handlers[key];

    if (typeof fn === 'function') {
      _this2[TARGET_PROP_NAME][key] = modifier(fn, _this2);
    }
  });
}

function component() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var state = options.state,
      template = options.template,
      instanceProps = options.instanceProps,
      componentDidMount = options.componentDidMount,
      componentDidUpdate = options.componentDidUpdate,
      componentWillUnmount = options.componentWillUnmount,
      shouldComponentUpdate = options.shouldComponentUpdate,
      componentWillReceiveProps = options.componentWillReceiveProps,
      rest = _objectWithoutProperties(options, ["state", "template", "instanceProps", "componentDidMount", "componentDidUpdate", "componentWillUnmount", "shouldComponentUpdate", "componentWillReceiveProps"]);

  var actions = options.actions,
      watcher = options.watcher;
  return function wrapper(InnerComponent) {
    return (
      /*#__PURE__*/
      function (_Component) {
        _inherits(Wrapper, _Component);

        function Wrapper(props) {
          var _this3;

          var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

          _classCallCheck(this, Wrapper);

          _this3 = _possibleConstructorReturn(this, _getPrototypeOf(Wrapper).call(this, props, context));

          var setState = function setState(newState, cb) {
            if (typeof cb === 'function') {
              _this3.setState(_objectSpread({}, newState), cb);
            } else _this3.setState(_objectSpread({}, newState));
          };

          var getState = function getState() {
            return _this3.state;
          };

          var _self = _assertThisInitialized(_this3);

          _this3.state = typeof state === 'function' ? state(props) : {};
          _this3.__store__ = Wrapper.__store__;

          if (_this3.__store__) {
            watcher = _this3.__store__.watcher;
            actions = _this3.__store__.actions;
          }

          var pluck = (0, _getProps["default"])(watcher);

          var instancePropsClone = _objectSpread({}, instanceProps); // Attach handlers


          bindHandler.call(_assertThisInitialized(_this3), actions, store.action, ACTION_KEY);
          bindHandler.call(_assertThisInitialized(_this3), rest, _this3.proxy, HANDLER_KEY);
          attachInstanceProps.call(_assertThisInitialized(_this3), instancePropsClone);
          var globalState = _this3.__store__ ? pluck(store ? store.getState() : {}) : {}; // keep the previous state

          var lastGlobalState = '{}';
          var currentGlobalState = '{}';

          var updateStore = function updateStore() {
            if (!_this3.__store__) {
              return;
            }

            lastGlobalState = currentGlobalState;
            var localState = pluck(store ? store.getState() : {}); // if store value does change, do not call update

            for (var i in localState) {
              if (localState[i] !== globalState[i]) {
                globalState = localState;
                return _this3.setState({});
              }
            } // if above condition fails & store contains additional props
            // update & cause re-render


            for (var _i in globalState) {
              if (!(_i in localState)) {
                globalState = localState;
                return _this3.setState({});
              }
            }
          };

          _this3.mergeProps = function () {
            var state = _self.state,
                instanceProps = _self.instanceProps,
                setInstanceProps = _self.setInstanceProps,
                getInstanceProps = _self.getInstanceProps;

            var parentProps = _objectSpread({}, props, {}, _this3.props);

            if (shouldComponentUpdate) {
              currentGlobalState = JSON.stringify(_objectSpread({}, parentProps, {}, globalState, {
                instanceProps: instanceProps,
                state: state
              }));
            }

            return _objectSpread({}, parentProps, {}, globalState, {}, _self[ACTION_KEY], {}, _self[HANDLER_KEY], {
              state: state,
              setState: setState,
              getState: getState,
              instanceProps: instanceProps,
              getInstanceProps: getInstanceProps,
              setInstanceProps: setInstanceProps
            });
          };

          _this3.componentDidMount = function () {
            if (_this3.__store__) {
              store.subscribe(updateStore);
            }

            componentDidMount && componentDidMount.call(null, _this3.mergeProps());
          };

          _this3.componentDidUpdate = function () {
            if (componentDidUpdate) return componentDidUpdate.call(null, _this3.mergeProps());
          };

          _this3.componentWillUnmount = function () {
            if (_this3.__store__) {
              store.unsubscribe(updateStore);
            }

            componentWillUnmount && componentWillUnmount.call(null, _this3.mergeProps());
          };

          _this3.componentWillReceiveProps = function (nxtProps) {
            componentWillReceiveProps && componentWillReceiveProps.call(null, nxtProps, _this3.mergeProps());
          };

          _this3.shouldComponentUpdate = function () {
            if (shouldComponentUpdate) {
              var nextProps = _this3.mergeProps();

              var prevProps = JSON.parse(lastGlobalState);
              return shouldComponentUpdate.call(null, {
                nextProps: nextProps,
                prevProps: prevProps
              });
            }

            return true;
          };

          _this3.render = function (props) {
            var view = template || InnerComponent;
            return h(view, _this3.mergeProps());
          };

          return _this3;
        }

        _createClass(Wrapper, [{
          key: "proxy",
          value: function proxy(func, context) {
            return func && function hook() {
              return func.apply(null, [this.mergeProps()].concat(Array.prototype.slice.call(arguments)));
            }.bind(context);
          }
        }]);

        return Wrapper;
      }(_react.Component)
    );
  };
}

function injectStore(appStore) {
  store = appStore;
}