"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _callbacks = _interopRequireDefault(require("./callbacks"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var log = function log(type) {
  if (process.env.NODE_ENV !== 'production') {
    console.log("%c action --> ".concat(type), 'color: green; font-weight: bold;');
  }
};

function actionCreator(actionName) {
  var actionConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function (getState, middleware, dispatch) {
    var payload = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var behaviors = arguments.length > 4 ? arguments[4] : undefined;
    var url = actionConfig.url,
        key = actionConfig.key;

    if (!middleware.length) {
      if (!url && key) {
        log(actionName);
        return dispatch(_defineProperty({}, key, result));
      }

      if (!url && !key) {
        log(actionName);
        return payload;
      }
    }

    var next = function next(result) {
      if (result) {
        if (result.then) {
          return result.then(function (data) {
            return _defineProperty({}, key, data);
          }).then(dispatch);
        }

        var updatedData = (0, _callbacks["default"])(actionConfig, {
          data: result,
          key: key,
          getState: getState,
          payload: payload,
          behaviors: behaviors
        });
        var data = updatedData.data;
        return dispatch(_defineProperty({}, key, data));
      }
    };

    var o = (0, _util.compose)(middleware, {
      actionName: actionName,
      actionConfig: actionConfig,
      behaviors: behaviors,
      payload: payload
    })({
      actionName: actionName,
      actionConfig: actionConfig,
      behaviors: behaviors,
      payload: payload
    }, next);
    o(payload);
  };
}

var _default = actionCreator;
exports["default"] = _default;